""" 
 *
 * Jon Klooster (2005)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
""" 



""" 
  this module provides two functions to read and write values
  to/from a specific device_IP/port/pin for an elexol microcontroller
"""
from socket import socket, AF_INET, SOCK_DGRAM

#===============================================================================
def test_input(cable,pin,value,func):
  err = 1
  cable = cable.upper()
  if cable<>'A' and cable<>'B' and cable<>'C':
    err = 0
  if func=='write':
    if pin==0 and value>=0 and value<256:
      err = 0
    if pin>0 and pin<9 and value>=0 and value<=1:
      err = 0
  if func=='read':
    if pin>=0 and pin<9:
      err = 0
  if err>0:
    print "DEBUG: elexol."+func+"_pin() called with invalid arguments!"
    print "   cable="+str(cable)
    print "   pin="+str(pin)
    print "   value="+str(value)
  return err

#===============================================================================
def read_pin(ip,port,cable,pin):
  if test_input(cable,pin,0,'read')>0:
    return
  cable = cable.lower()
  mySocket = socket(AF_INET, SOCK_DGRAM)
  mySocket.sendto(cable, (ip, port) )
  (data, addr) = mySocket.recvfrom(50)
  mySocket.close()
  if pin==0:
    return ord(data[1:])
  else:
    return extract_bit(pin,ord(data[1:]))

#===============================================================================
def write_pin(ip,port,cable,pin,value):
  if test_input(cable,pin,value,'write')>0:
    return
  cable = cable.upper()
  # write a preset number
  if pin==0:
    s = '!'+cable + chr(0) + cable + chr(value)
  # write just a single pin
  else:
    v = read_pin(ip,port,cable,0)
    v = set_bit(v,pin,value)
    s = '!'+cable + chr(0) + cable + chr(v)
  mySocket = socket(AF_INET, SOCK_DGRAM)
  mySocket.sendto(s, (ip, port) )
  mySocket.close()
  v = read_pin(ip,port,cable,pin)
  if v<>value:
    print 'ERROR: failed to write value to device.'
  return -1

#===============================================================================
def set_bit(value,bit,setto):
  v = extract_bit(bit,value)
  if v==setto:
    return value
  bit = 2**(bit-1)
  if setto==0:
    return (value - bit)
  else:
    return (value + bit)

#===============================================================================
def extract_bit(bit,value):
  bit = 2**(bit-1)
  if bit & value: return 1
  return 0
